#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1500one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 1500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1500one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one15004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                         
# -------------------------------------------------------------------------------------------------
# 1500
# -------------------------------------------------------------------------------------------------                                          
shot2one15004xi = {
                  1:'0x0y1499z',
                  2:'0x45y1499z',
                  3:'0x993y1124z',
                  4:'101x965y1143z',
                  5:'1024x777y772z',
                  6:'116x1387y557z',
                  7:'137x1329y680z',
                  8:'14x164y1490z',
                  9:'150x1229y845z',
                  10:'150x947y1153z',
                  11:'156x1116y989z',
                  12:'15x25y1499z',
                  13:'188x1374y571z',
                  14:'196x926y1162z',
                  15:'1x15y1499z',
                  16:'1x30y1499z',
                  17:'205x1313y693z',
                  18:'213x1096y1000z',
                  19:'213x1211y858z',
                  20:'21x1255y820z',
                  21:'21x148y1492z',
                  22:'21x39y1499z',
                  23:'242x903y1172z',
                  24:'259x1356y585z',
                  25:'267x1074y1012z',
                  26:'26x132y1493z',
                  27:'26x53y1498z',
                  28:'273x1294y706z',
                  29:'274x1190y870z',
                  30:'285x878y1181z',
                  31:'29x116y1495z',
                  32:'29x68y1498z',
                  33:'30x100y1496z',
                  34:'31x84y1497z',
                  35:'320x1048y1023z',
                  36:'326x851y1190z',
                  37:'328x1335y598z',
                  38:'333x1166y882z',
                  39:'338x1271y720z',
                  40:'366x822y1199z',
                  41:'371x1021y1034z',
                  42:'391x1138y894z',
                  43:'396x1310y612z',
                  44:'402x1245y733z',
                  45:'403x791y1208z',
                  46:'40x1145y967z',
                  47:'420x990y1044z',
                  48:'437x758y1217z',
                  49:'447x1108y906z',
                  50:'44x1397y543z',
                  51:'462x1282y626z',
                  52:'464x1215y746z',
                  53:'467x957y1055z',
                  54:'470x724y1226z',
                  55:'47x36y1498z',
                  56:'500x1075y918z',
                  57:'500x688y1234z',
                  58:'511x922y1066z',
                  59:'51x980y1134z',
                  60:'524x1182y759z',
                  61:'526x1250y639z',
                  62:'528x652y1243z',
                  63:'551x1039y930z',
                  64:'553x614y1251z',
                  65:'553x885y1076z',
                  66:'56x49y1498z',
                  67:'575x575y1259z',
                  68:'582x1146y772z',
                  69:'587x1215y653z',
                  70:'592x846y1087z',
                  71:'595x536y1268z',
                  72:'600x1000y941z',
                  73:'612x496y1275z',
                  74:'627x456y1283z',
                  75:'629x805y1097z',
                  76:'637x1108y784z',
                  77:'646x960y953z',
                  78:'647x1177y666z',
                  79:'64x62y1497z',
                  80:'663x763y1107z',
                  81:'68x1341y666z',
                  82:'690x1066y797z',
                  83:'690x917y965z',
                  84:'695x719y1117z',
                  85:'6x179y1489z',
                  86:'704x1135y680z',
                  87:'71x76y1496z',
                  88:'723x674y1127z',
                  89:'731x872y976z',
                  90:'740x1022y810z',
                  91:'749x628y1137z',
                  92:'759x1091y693z',
                  93:'769x825y987z',
                  94:'771x581y1147z',
                  95:'77x91y1495z',
                  96:'787x975y822z',
                  97:'791x534y1156z',
                  98:'804x777y999z',
                  99:'811x1045y706z',
                  100:'81x107y1493z',
                  101:'832x927y835z',
                  102:'836x727y1010z',
                  103:'83x124y1492z',
                  104:'84x141y1490z',
                  105:'84x158y1489z',
                  106:'860x995y720z',
                  107:'865x676y1021z',
                  108:'86x1244y833z',
                  109:'873x876y847z',
                  110:'87x187y1586z',
                  111:'891x624y1032z',
                  112:'8x12y1499z',
                  113:'905x944y733z',
                  114:'911x823y860z',
                  115:'947x769y872z',
                  116:'948x890y746z',
                  117:'978x713y884z',
                  118:'988x834y759z',
                  119:'99x1132y978z'}
                  

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1500one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1500one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE150ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE150ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE150ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE150ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE150ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE15004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one15004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE150ONE4XI - SUCCEEDED TO PUT SHOT2ONE15004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE15004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE150ONE4XI *** FAILED TO PUT SHOT2ONE15004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE150ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one15004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one15004xi</nack2put4xi>" 
                  
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
   
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE150ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one15004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE150ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE150ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1500one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
